import * as React from "react";
import PropTypes from "prop-types";
import type { TKakaoStrokeStyles } from "tenel-kakao-map";
export interface IKakaoMapsCircleProps {
    className?: string;
    center: {
        lat: number;
        lng: number;
    };
    /** 단위 : m */
    radius?: number;
    fillColor?: string;
    fillOpacity?: number;
    /** 단위 : px */
    strokeWeight?: number;
    strokeColor?: string;
    strokeOpacity?: number;
    strokeStyle?: TKakaoStrokeStyles;
    zIndex?: number;
    onClick?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onMouseDown?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onMouseMove?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onMouseOver?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onMouseOut?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
}
declare function Circle(props: React.PropsWithChildren<IKakaoMapsCircleProps>): JSX.Element;
declare namespace Circle {
    var defaultProps: {
        radius: number;
        fillColor: string;
        fillOpacity: number;
        strokeColor: string;
        strokeWeight: number;
        strokeOpacity: number;
        strokeStyle: string;
        zIndex: number;
    };
    var propTypes: {
        /** 맵에 표시될 좌표 */
        center: PropTypes.Validator<PropTypes.InferProps<{
            lat: PropTypes.Validator<number>;
            lng: PropTypes.Validator<number>;
        }>>;
        /** 단위 : m */
        radius: PropTypes.Requireable<number>;
        /** 채움 색 */
        fillColor: PropTypes.Requireable<string>;
        /** 채움 색의 불투명도 ( 0 ~ 1 ) */
        fillOpacity: PropTypes.Requireable<number>;
        /** 채움 색 */
        strokeColor: PropTypes.Requireable<string>;
        /** 채움 불투명도 ( 0 ~ 1 ) */
        strokeOpacity: PropTypes.Requireable<number>;
        /** 선의 두께 ( 단위 : px ) */
        strokeWeight: PropTypes.Requireable<number>;
        /** 선 스타일 */
        strokeStyle: PropTypes.Requireable<string>;
        /** z-index 속성 값 */
        zIndex: PropTypes.Requireable<number>;
        /** (e: { position: { lat: number, lng: number } }) => void */
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        /** (e: { position: { lat: number, lng: number } }) => void */
        onMouseDown: PropTypes.Requireable<(...args: any[]) => any>;
        /** (e: { position: { lat: number, lng: number } }) => void */
        onMouseMove: PropTypes.Requireable<(...args: any[]) => any>;
        /** (e: { position: { lat: number, lng: number } }) => void */
        onMouseOver: PropTypes.Requireable<(...args: any[]) => any>;
        /** (e: { position: { lat: number, lng: number } }) => void */
        onMouseOut: PropTypes.Requireable<(...args: any[]) => any>;
    };
}
export default Circle;
