import { TKakaoStrokeStyles, TKakaoDrawingOverayTypeValue } from "tenel-kakao-map";
import * as React from "react";
import PropTypes from "prop-types";
export interface IKakaoMapsDrawingManagerProps {
    className?: string;
    shape?: TKakaoDrawingOverayTypeValue | "none";
    fill?: string;
    fillOpacity?: number;
    stroke?: string;
    strokeStyle?: TKakaoStrokeStyles;
    strokeWidth?: number;
    strokeOpacity?: number;
    hintStrokeStyle?: TKakaoStrokeStyles;
    hintStrokeOpacity?: number;
    onDrawend: (shape: any) => void;
}
declare function DrawingManager(props: React.PropsWithChildren<IKakaoMapsDrawingManagerProps>): JSX.Element;
declare namespace DrawingManager {
    var defaultProps: {
        shape: string;
        fill: string;
        fillOpacity: number;
        stroke: string;
        strokeOpacity: number;
        strokeWidth: number;
        strokeStyle: string;
        hintStrokeStyle: string;
        hintStrokeOpacity: number;
    };
    var propTypes: {
        /** 그리기 모양 */
        shape: PropTypes.Requireable<string>;
        /** 선 색 (기본값: #39f) */
        stroke: PropTypes.Requireable<string>;
        /** 선의 두께 (기본값: 3) */
        strokeWidth: PropTypes.Requireable<number>;
        /** 보조선 스타일 */
        strokeStyle: PropTypes.Requireable<string>;
        /** 선의 불투명도 (0-1, 기본값: 1.0) */
        strokeOpacity: PropTypes.Requireable<number>;
        /** 채우기 색 (기본값: #39f) */
        fill: PropTypes.Requireable<string>;
        /** 채우기 불투명도 (0-1, 기본값: 1.0) */
        fillOpacity: PropTypes.Requireable<number>;
        /** 보조선 스타일 */
        hintStrokeStyle: PropTypes.Requireable<string>;
        /** 보조선 불투명도 (0-1, 기본값: 1.0) */
        hintStrokeOpacity: PropTypes.Requireable<number>;
        onDrawend: PropTypes.Validator<(...args: any[]) => any>;
    };
}
export default DrawingManager;
