"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var prop_types_1 = __importDefault(require("prop-types"));
var context_1 = __importDefault(require("./context"));
var context_2 = __importDefault(require("../Map/context"));
function Ellipse(props) {
    var map = React.useContext(context_2.default).map;
    var ellipse = React.useMemo(function () {
        var options = {
            center: new kakao.maps.LatLng(props.position.lat, props.position.lng),
            rx: props.rx,
            ry: props.ry,
            fillColor: props.fillColor,
            fillOpacity: props.fillOpacity,
            strokeColor: props.strokeColor,
            strokeWeight: props.strokeWeight,
            strokeOpacity: props.strokeOpacity,
            strokeStyle: props.strokeStyle,
            zIndex: props.zIndex,
        };
        var $ellipse = new kakao.maps.Ellipse(options);
        return $ellipse;
    }, []);
    React.useEffect(function () {
        ellipse.setMap(map);
        return function () { return ellipse.setMap(null); };
    }, []);
    var listeners = React.useRef({});
    listeners.current.onClick = function onClick(e) {
        var _a;
        (_a = props.onClick) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseMove = function onMouseMove(e) {
        var _a;
        (_a = props.onMouseMove) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseDown = function onMouseDown(e) {
        var _a;
        (_a = props.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseOver = function onMouseOver(e) {
        var _a;
        (_a = props.onMouseOver) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseOut = function onMouseOut(e) {
        var _a;
        (_a = props.onMouseOut) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    React.useEffect(function () {
        kakao.maps.event.addListener(ellipse, "click", listeners.current.onClick);
        kakao.maps.event.addListener(ellipse, "mousemove", listeners.current.onMouseMove);
        kakao.maps.event.addListener(ellipse, "mousedown", listeners.current.onMouseDown);
        kakao.maps.event.addListener(ellipse, "mouseover", listeners.current.onMouseOver);
        kakao.maps.event.addListener(ellipse, "mouseout", listeners.current.onMouseOut);
        return function () {
            kakao.maps.event.removeListener(ellipse, "click", listeners.current.onClick);
            kakao.maps.event.removeListener(ellipse, "mousemove", listeners.current.onMouseMove);
            kakao.maps.event.removeListener(ellipse, "mousedown", listeners.current.onMouseDown);
            kakao.maps.event.removeListener(ellipse, "mouseover", listeners.current.onMouseOver);
            kakao.maps.event.removeListener(ellipse, "mouseout", listeners.current.onMouseOut);
        };
    }, []);
    React.useEffect(function () {
        var latlng = new kakao.maps.LatLng(props.position.lat, props.position.lng);
        ellipse.setPosition(latlng);
    }, [props.position.lat, props.position.lng]);
    React.useEffect(function () {
        ellipse.setRadius(props.rx, props.ry);
    }, [props.rx, props.ry]);
    React.useEffect(function () {
        ellipse.setOptions({ fillColor: props.fillColor });
    }, [props.fillColor]);
    React.useEffect(function () {
        ellipse.setOptions({ fillOpacity: props.fillOpacity });
    }, [props.fillOpacity]);
    React.useEffect(function () {
        ellipse.setOptions({ strokeWeight: props.strokeWeight });
    }, [props.strokeWeight]);
    React.useEffect(function () {
        ellipse.setOptions({ strokeColor: props.strokeColor });
    }, [props.strokeColor]);
    React.useEffect(function () {
        ellipse.setOptions({ strokeOpacity: props.strokeOpacity });
    }, [props.strokeOpacity]);
    React.useEffect(function () {
        ellipse.setOptions({ strokeStyle: props.strokeStyle });
    }, [props.strokeStyle]);
    React.useEffect(function () {
        ellipse.setZIndex(props.zIndex);
    }, [props.zIndex]);
    return (React.createElement(context_1.default.Provider, { value: { ellipse: ellipse } }, props.children));
}
Ellipse.defaultProps = {
    fillColor: "transparent",
    fillOpacity: 1,
    strokeColor: "#000",
    strokeWeight: 1,
    strokeOpacity: 1,
    strokeStyle: "solid",
    zIndex: 0,
};
Ellipse.propTypes = {
    /** 맵에 표시될 좌표 */
    position: prop_types_1.default.shape({
        lat: prop_types_1.default.number.isRequired,
        lng: prop_types_1.default.number.isRequired,
    }).isRequired,
    /** 단위 : m */
    rx: prop_types_1.default.number.isRequired,
    /** 단위 : m */
    ry: prop_types_1.default.number.isRequired,
    /** 채움 색 */
    fillColor: prop_types_1.default.string,
    /** 채움 색의 불투명도 ( 0 ~ 1 ) */
    fillOpacity: prop_types_1.default.number,
    /** 선 색 */
    strokeColor: prop_types_1.default.string,
    /** 선 불투명도 ( 0 ~ 1 ) */
    strokeOpacity: prop_types_1.default.number,
    /** 선의 두께 ( 단위 : px ) */
    strokeWeight: prop_types_1.default.number,
    /** 선 스타일 */
    strokeStyle: prop_types_1.default.oneOf(["solid", "shortdash", "shortdot", "shortdashdot", "shortdashdotdot", "dot", "dash", "dashdot", "longdash", "longdashdot", "longdashdotdot"]),
    /** z-index 속성 값 */
    zIndex: prop_types_1.default.number,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onClick: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseDown: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseMove: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseOver: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseOut: prop_types_1.default.func,
};
exports.default = Ellipse;
