import * as React from "react";
import type { IKakaoCopyrightPosition, TKakaoOverayMapTypeIdKey, TKakaoBaseMapTypeIdKey, IKakaoMap } from "tenel-kakao-map";
export interface IKakaoMapsMapRef {
    map: IKakaoMap;
}
export interface IKakaoMapsMapProps {
    container?: HTMLElement;
    center: {
        lat: number;
        lng: number;
    };
    baseMapType?: TKakaoBaseMapTypeIdKey;
    overlayMapTypes?: TKakaoOverayMapTypeIdKey[];
    customOverlayMapTypes?: string;
    cursor?: string;
    draggable?: boolean;
    zoomable?: boolean;
    level?: number;
    minLevel?: number;
    maxLevel?: number;
    levelDuration?: number;
    copyright?: {
        position: keyof IKakaoCopyrightPosition;
        reverse?: boolean;
    };
    bounds?: {
        value: [{
            lat: number;
            lng: number;
        }, {
            lat: number;
            lng: number;
        }];
        paddingTop?: number;
        paddingRight?: number;
        paddingBottom?: number;
        paddingLeft?: number;
    };
    onZoomStart?: (e: {
        zoomLevel: number;
    }) => void;
    onZoomChange?: (e: {
        zoomLevel: number;
    }) => void;
    onClick?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onRightClick?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onDoubleClick?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onDrag?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onDragEnd?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onDragStart?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onMouseMove?: (e: {
        position: {
            lat: number;
            lng: number;
        };
    }) => void;
    onTilesLoaded?: (e: {
        zoomLevel: number;
        position: {
            lat: number;
            lng: number;
        };
        bounds: [
            {
                lat: number;
                lng: number;
            },
            {
                lat: number;
                lng: number;
            }
        ];
    }) => void;
    onBoundsChanged?: (e: {
        bounds: [
            {
                lat: number;
                lng: number;
            },
            {
                lat: number;
                lng: number;
            }
        ];
    }) => void;
    /** bounds: [sw, ne] */
    onIdle?: (e: {
        zoomLevel: number;
        position: {
            lat: number;
            lng: number;
        };
        bounds: [
            {
                lat: number;
                lng: number;
            },
            {
                lat: number;
                lng: number;
            }
        ];
    }) => void;
}
declare const KakaoMap: React.ForwardRefExoticComponent<IKakaoMapsMapProps & {
    children?: React.ReactNode;
} & React.RefAttributes<IKakaoMapsMapRef>>;
export default KakaoMap;
