"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var prop_types_1 = __importDefault(require("prop-types"));
var context_1 = __importDefault(require("../Map/context"));
var context_2 = __importDefault(require("./context"));
var Position = prop_types_1.default.shape({
    lat: prop_types_1.default.number.isRequired,
    lng: prop_types_1.default.number.isRequired,
}).isRequired;
function Polygon(props) {
    var map = React.useContext(context_1.default).map;
    var polygon = React.useMemo(function () {
        var path = props.path.map(function (positionOrPath) {
            if ("lat" in positionOrPath) {
                return new kakao.maps.LatLng(positionOrPath.lat, positionOrPath.lng);
            }
            else {
                return positionOrPath.map(function (position) {
                    return new kakao.maps.LatLng(position.lat, position.lng);
                });
            }
        });
        var options = {
            path: path,
            fillColor: props.fillColor,
            fillOpacity: props.fillOpacity,
            strokeColor: props.strokeColor,
            strokeWeight: props.strokeWeight,
            strokeOpacity: props.strokeOpacity,
            strokeStyle: props.strokeStyle,
            zIndex: props.zIndex,
        };
        var $polygon = new kakao.maps.Polygon(options);
        return $polygon;
    }, []);
    React.useEffect(function () {
        polygon.setMap(map);
        return function () { return polygon.setMap(null); };
    }, []);
    var listeners = React.useRef({});
    listeners.current.onClick = function onClick(e) {
        var _a;
        (_a = props.onClick) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseMove = function onMouseMove(e) {
        var _a;
        (_a = props.onMouseMove) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseDown = function onMouseDown(e) {
        var _a;
        (_a = props.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseOver = function onMouseOver(e) {
        var _a;
        (_a = props.onMouseOver) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseOut = function onMouseOut(e) {
        var _a;
        (_a = props.onMouseOut) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    React.useEffect(function () {
        kakao.maps.event.addListener(polygon, "click", listeners.current.onClick);
        kakao.maps.event.addListener(polygon, "mousemove", listeners.current.onMouseMove);
        kakao.maps.event.addListener(polygon, "mousedown", listeners.current.onMouseDown);
        kakao.maps.event.addListener(polygon, "mouseover", listeners.current.onMouseOver);
        kakao.maps.event.addListener(polygon, "mouseout", listeners.current.onMouseOut);
        return function () {
            kakao.maps.event.removeListener(polygon, "click", listeners.current.onClick);
            kakao.maps.event.removeListener(polygon, "mousemove", listeners.current.onMouseMove);
            kakao.maps.event.removeListener(polygon, "mousedown", listeners.current.onMouseDown);
            kakao.maps.event.removeListener(polygon, "mouseover", listeners.current.onMouseOver);
            kakao.maps.event.removeListener(polygon, "mouseout", listeners.current.onMouseOut);
        };
    }, []);
    React.useEffect(function () {
        var path = props.path.map(function (positionOrPath) {
            if ("lat" in positionOrPath) {
                return new kakao.maps.LatLng(positionOrPath.lat, positionOrPath.lng);
            }
            else {
                return positionOrPath.map(function (position) {
                    return new kakao.maps.LatLng(position.lat, position.lng);
                });
            }
        });
        polygon.setPath(path);
    }, [props.path]);
    React.useEffect(function () {
        polygon.setOptions({ fillColor: props.fillColor });
    }, [props.fillColor]);
    React.useEffect(function () {
        polygon.setOptions({ fillOpacity: props.fillOpacity });
    }, [props.fillOpacity]);
    React.useEffect(function () {
        polygon.setOptions({ strokeColor: props.strokeColor });
    }, [props.strokeColor]);
    React.useEffect(function () {
        polygon.setOptions({ strokeWeight: props.strokeWeight });
    }, [props.strokeWeight]);
    React.useEffect(function () {
        polygon.setOptions({ strokeOpacity: props.strokeOpacity });
    }, [props.strokeOpacity]);
    React.useEffect(function () {
        polygon.setOptions({ strokeStyle: props.strokeStyle });
    }, [props.strokeStyle]);
    React.useEffect(function () {
        polygon.setZIndex(props.zIndex);
    }, [props.zIndex]);
    return (React.createElement(context_2.default.Provider, { value: { polygon: polygon } }, props.children));
}
Polygon.defaultProps = {
    fillColor: "transparent",
    fillOpacity: 1,
    strokeColor: "#000",
    strokeWeight: 1,
    strokeOpacity: 1,
    strokeStyle: "solid",
    zIndex: 0,
};
Polygon.propTypes = {
    /** Position : { lat: number, lng: number } */
    path: prop_types_1.default.oneOfType([
        prop_types_1.default.arrayOf(Position).isRequired,
        prop_types_1.default.arrayOf(prop_types_1.default.arrayOf(Position).isRequired).isRequired,
    ]).isRequired,
    /** 채움 색 */
    fillColor: prop_types_1.default.string,
    /** 채움 색의 불투명도 ( 0 ~ 1 ) */
    fillOpacity: prop_types_1.default.number,
    /** 선 색 */
    strokeColor: prop_types_1.default.string,
    /** 선 불투명도 ( 0 ~ 1 ) */
    strokeOpacity: prop_types_1.default.number,
    /** 선의 두께 ( 단위 : px ) */
    strokeWeight: prop_types_1.default.number,
    /** 선 스타일 */
    strokeStyle: prop_types_1.default.oneOf(["solid", "shortdash", "shortdot", "shortdashdot", "shortdashdotdot", "dot", "dash", "dashdot", "longdash", "longdashdot", "longdashdotdot"]),
    /** z-index 속성 값 */
    zIndex: prop_types_1.default.number,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onClick: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseDown: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseMove: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseOver: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseOut: prop_types_1.default.func,
};
exports.default = Polygon;
