"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var prop_types_1 = __importDefault(require("prop-types"));
var context_1 = __importDefault(require("./context"));
var context_2 = __importDefault(require("../Map/context"));
var Position = prop_types_1.default.shape({
    lat: prop_types_1.default.number.isRequired,
    lng: prop_types_1.default.number.isRequired,
}).isRequired;
function Polyline(props) {
    var map = React.useContext(context_2.default).map;
    var polyline = React.useMemo(function () {
        var options = {
            path: props.path.map(function (point) { return new kakao.maps.LatLng(point.lat, point.lng); }),
            strokeColor: props.strokeColor,
            strokeWeight: props.strokeWeight,
            strokeOpacity: props.strokeOpacity,
            strokeStyle: props.strokeStyle,
            endArrow: props.endArrow,
            zIndex: props.zIndex,
        };
        var $polyline = new kakao.maps.Polyline(options);
        return $polyline;
    }, []);
    React.useEffect(function () {
        polyline.setMap(map);
        return function () { return polyline.setMap(null); };
    }, []);
    var listeners = React.useRef({});
    listeners.current.onClick = function onClick(e) {
        var _a;
        (_a = props.onClick) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseMove = function onMouseMove(e) {
        var _a;
        (_a = props.onMouseMove) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseDown = function onMouseDown(e) {
        var _a;
        (_a = props.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseOver = function onMouseOver(e) {
        var _a;
        (_a = props.onMouseOver) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    listeners.current.onMouseOut = function onMouseOut(e) {
        var _a;
        (_a = props.onMouseOut) === null || _a === void 0 ? void 0 : _a.call(props, {
            position: {
                lat: e.latLng.getLat(),
                lng: e.latLng.getLng(),
            },
        });
    };
    React.useEffect(function () {
        kakao.maps.event.addListener(polyline, "click", listeners.current.onClick);
        kakao.maps.event.addListener(polyline, "mousemove", listeners.current.onMouseMove);
        kakao.maps.event.addListener(polyline, "mousedown", listeners.current.onMouseDown);
        kakao.maps.event.addListener(polyline, "mouseover", listeners.current.onMouseOver);
        kakao.maps.event.addListener(polyline, "mouseout", listeners.current.onMouseOut);
        return function () {
            kakao.maps.event.removeListener(polyline, "click", listeners.current.onClick);
            kakao.maps.event.removeListener(polyline, "mousemove", listeners.current.onMouseMove);
            kakao.maps.event.removeListener(polyline, "mousedown", listeners.current.onMouseDown);
            kakao.maps.event.removeListener(polyline, "mouseover", listeners.current.onMouseOver);
            kakao.maps.event.removeListener(polyline, "mouseout", listeners.current.onMouseOut);
        };
    }, []);
    React.useEffect(function () {
        var _a;
        (_a = props.onPolylineLengthChange) === null || _a === void 0 ? void 0 : _a.call(props, polyline.getLength());
        polyline.setPath(props.path.map(function (position) {
            return new kakao.maps.LatLng(position.lat, position.lng);
        }));
    }, [props.path]);
    React.useEffect(function () {
        polyline.setOptions({ strokeColor: props.strokeColor });
    }, [props.strokeColor]);
    React.useEffect(function () {
        polyline.setOptions({ strokeWeight: props.strokeWeight });
    }, [props.strokeWeight]);
    React.useEffect(function () {
        polyline.setOptions({ strokeOpacity: props.strokeOpacity });
    }, [props.strokeOpacity]);
    React.useEffect(function () {
        polyline.setOptions({ strokeStyle: props.strokeStyle });
    }, [props.strokeStyle]);
    React.useEffect(function () {
        polyline.setZIndex(props.zIndex);
    }, [props.zIndex]);
    return (React.createElement(context_1.default.Provider, { value: { polyline: polyline } }, props.children));
}
Polyline.defaultProps = {
    strokeColor: "#000",
    strokeWeight: 1,
    strokeOpacity: 1,
    strokeStyle: "solid",
    endArrow: false,
    zIndex: 0,
};
Polyline.propTypes = {
    /** Position : { lat: number, lng: number } */
    path: prop_types_1.default.arrayOf(Position).isRequired,
    /** 선 색 */
    strokeColor: prop_types_1.default.string,
    /** 선 불투명도 ( 0 ~ 1 ) */
    strokeOpacity: prop_types_1.default.number,
    /** 선의 두께 ( 단위 : px ) */
    strokeWeight: prop_types_1.default.number,
    /** 선 스타일 */
    strokeStyle: prop_types_1.default.oneOf(["solid", "shortdash", "shortdot", "shortdashdot", "shortdashdotdot", "dot", "dash", "dashdot", "longdash", "longdashdot", "longdashdotdot"]),
    /** z-index 속성 값 */
    zIndex: prop_types_1.default.number,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onClick: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseDown: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseMove: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseOver: prop_types_1.default.func,
    /** (e: { position: { lat: number, lng: number } }) => void */
    onMouseOut: prop_types_1.default.func,
};
exports.default = Polyline;
