/// <reference types="react" />
import Marker from "./Marker";
import Circle from "./Circle";
import Rectangle from "./Rectangle";
import Ellipse from "./Ellipse";
import Polygon from "./Polygon";
import Polyline from "./Polyline";
import DrawingManager from "./DrawingManager";
declare const KakaoMaps: {
    Map: import("react").ForwardRefExoticComponent<import("./Map").IKakaoMapsMapProps & {
        children?: import("react").ReactNode;
    } & import("react").RefAttributes<import("./Map").IKakaoMapsMapRef>>;
    MapContext: import("react").Context<{
        map: import("tenel-kakao-map").IKakaoMap;
    }>;
    Marker: typeof Marker;
    MarkerContext: import("react").Context<{
        marker: import("tenel-kakao-map").IKakaoMarker;
    }>;
    CustomOverlay: import("react").FunctionComponent<import("./CustomOverlay").IKakaoMapsCustomOverlayProps>;
    CustomOverlayContext: import("react").Context<{
        customOverlay: import("tenel-kakao-map").IKakaoCustomOverlay;
    }>;
    Circle: typeof Circle;
    CircleContext: import("react").Context<{
        circle: import("tenel-kakao-map").IKakaoCircle;
    }>;
    Rectangle: typeof Rectangle;
    RectangleContext: import("react").Context<{
        rectangle: import("tenel-kakao-map").IKakaoRectangle;
    }>;
    Ellipse: typeof Ellipse;
    EllipseContext: import("react").Context<{
        ellipse: import("tenel-kakao-map").IKakaoEllipse;
    }>;
    Polygon: typeof Polygon;
    PolygonContext: import("react").Context<{
        polygon: import("tenel-kakao-map").IKakaoPolygon;
    }>;
    Polyline: typeof Polyline;
    PolylineContext: import("react").Context<{
        polyline: import("tenel-kakao-map").IKakaoPolyline;
    }>;
    DrawingManager: typeof DrawingManager;
    DrawingManagerContext: import("react").Context<{
        drawingManager: import("tenel-kakao-map").IKakaoDrawingManager;
    }>;
};
export = KakaoMaps;
